// MythRemote - copyright David Kuder (GrizzlyAdams) 2007
// Based on DSWifi Test Project - copyright Stephen Stair 2005
// Based on template project in ndslib by wntrmute
/****************************************************************************** 
DSWifi Lib and test materials are licenced under the MIT open source licence:
Copyright (c) 2005 Stephen Stair

MythRemote is also licensed under the MIT open source license:
Copyright (c) 2007 David Kuder

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
******************************************************************************/

// 3D Transition code from MythRemote - copyright 2007 David Kuder (Grizzly Adams)

#include "nds.h"
#include <nds/arm9/console.h> //basic print funcionality
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <errno.h>

#include "3deffect.h"

//int strange_voodoo=0;
//draw a cube face at the specified color
 void drawQuad(void)
{	
	glNormal(NORMAL_PACK(0,inttov10(-1),0));

	glTexCoord1i(TEXTURE_PACK(inttot16(224/*-strange_voodoo*/), 	inttot16(0)));
	glVertex3v16(floattov16(-0.5),				floattov16(-0.375), 0 );
	
	glTexCoord1i(TEXTURE_PACK(inttot16(224/*-strange_voodoo*/),	inttot16(256)));
	glVertex3v16(floattov16(0.5),					floattov16(-0.375), 0 );
	
	glTexCoord1i(TEXTURE_PACK(inttot16(32/*-strange_voodoo*/), 		inttot16(256)));
	glVertex3v16(floattov16(0.5),					floattov16(0.375), 0 );

	glTexCoord1i(TEXTURE_PACK(inttot16(32/*-strange_voodoo*/),		inttot16(0)));
	glVertex3v16(floattov16(-0.5),				floattov16(0.375), 0 );
}

#define abs(x) ((x<0) ? -x : x)
void Render3DEffect(int Effect, int textureID, float r) {
	float rotateX = 0.0;
	float rotateY = 0.0;

	if(Effect & Effect_Left)		rotateY = r;
	else if (Effect & Effect_Right)	rotateY = -r;

	if (Effect & Effect_Up)			rotateX = r;
	else if (Effect & Effect_Down)	rotateX = -r;

#if 0
	if (Effect & Effect_Fade) {
		BLEND_CR = BLEND_FADE_BLACK | BLEND_SRC_BG3;
		BLEND_Y = 1+(abs(r)/3);
	} else {
		BLEND_CR = BLEND_NONE;
	}
#endif

	glReset();

	//any floating point gl call is being converted to fixed prior to being implemented
	gluPerspective(35, 256.0 / 192.0, 0.1, 40);


	gluLookAt(	0.0, 0.0, 1.0,		//camera possition 
			0.0, 0.0, 0.0,		//look at
			0.0, 1.0, 0.0);		//up


	glPushMatrix();

	//move it away from the camera
	glTranslate3f32(0, 0, floattof32(-0.05+0.5));

	glRotateX(rotateX);
	glRotateY(rotateY);

	glMatrixMode(GL_TEXTURE);
	glIdentity();

	glMatrixMode(GL_MODELVIEW);

	glMaterialf(GL_AMBIENT, 0x7fff);
	glMaterialf(GL_DIFFUSE, 0x7fff);
	glMaterialf(GL_SPECULAR, BIT(15));
	glMaterialf(GL_EMISSION, 0x7fff);

	//ds uses a table for shinyness..this generates a half-ass one
	glMaterialShinyness();

	//not a real gl function and will likely change
		glPolyFmt(POLY_ALPHA(31) | POLY_CULL_BACK ) ;
														

	glBindTexture(0, textureID);

	//draw the obj
	glBegin(GL_QUAD);

	drawQuad();

	glEnd();

	glPopMatrix(1);

	glFlush();

	swiWaitForVBlank();
}

extern void glTexParameter(	uint8 sizeX, uint8 sizeY, uint32* addr, uint8 mode, uint32 param);
extern uint32* getNextTextureSlot(int size);
//---------------------------------------------------------------------------------
// Similer to glTextImage2D from gl it takes a pointer to data
//  Empty fields and target are unused but provided for code compatibility.
//  type is simply the texture type (GL_RGB, GL_RGB8 ect...)
//---------------------------------------------------------------------------------
int glTexImage2D_HACK(int target, int empty1, int type,
                 int sizeX, int sizeY,
                 int empty2, int param,
                 uint8* texture) {
//---------------------------------------------------------------------------------
  uint32 size = 0;
  uint32* addr;
//  uint32 vramTemp;

  size = 1 << (sizeX + sizeY + 6);

  switch (type) {
    case GL_RGB:
    case GL_RGBA:
      size = size << 1;
      break;
    case GL_RGB4:
      size = size >> 2;
      break;
    case GL_RGB16:
      size = size >> 1;
      break;

    default:
      break;
  }
  
  addr = getNextTextureSlot(size);
  
  if(!addr)
    return 0;

  swiWaitForVBlank();
  // unlock texture memory
//  vramTemp = vramSetMainBanks(VRAM_A_LCD,VRAM_B_LCD,VRAM_C_LCD,VRAM_D_LCD);

//  if (type == GL_RGB) {
    // We do GL_RGB as GL_RGBA, but we set each alpha bit to 1 during the copy
    u16 * src = (u16*)texture;
    u16 * dest = (u16*)addr;
    
    glTexParameter(sizeX, sizeY, addr, GL_RGBA, param);
    
    while (size--) {
      *dest++ = *src | (1 << 15);
      src++;
    }
//  } else {
    // For everything else, we do a straight copy
//    glTexParameter(sizeX, sizeY, addr, type, param);
//    swiCopy((uint32*)texture, addr, size / 4 | COPY_MODE_WORD);
//  }

//  vramRestoreMainBanks(vramTemp);

  return 1;
}

void Do3DEffect(int Effect, unsigned short *Screen) {
	int r;
	int textureID;

	BLEND_CR=BLEND_NONE;

	DC_FlushAll();

	vramSetBankA(VRAM_A_TEXTURE);
	glResetTextures();

	glGenTextures(1, &textureID);
	glBindTexture(0, textureID);
//	if(Effect & Effect_In) {
		glTexImage2D(0, 0, GL_RGBA, TEXTURE_SIZE_256, TEXTURE_SIZE_256, 0, TEXGEN_TEXCOORD, (u8*)Screen);
//		strange_voodoo=0;
//	} else {
//		glTexImage2D_HACK(0, 0, GL_RGBA, TEXTURE_SIZE_256, TEXTURE_SIZE_256, 0, TEXGEN_TEXCOORD, (u8*)Screen);
//		strange_voodoo=32;
//	}

	videoSetMode(MODE_0_3D);

	glViewPort(0,0,255,191);
		
	glClearColor(0,0,0);
	glClearDepth(0x7FFF);

	float a = (Effect & Effect_In) ? -90 : 0;
	for(r=0;r<=90;r+=3) {
		Render3DEffect(Effect & 0xf, textureID, a);
		a+=3;
	}
}
