// MythRemote - copyright David Kuder (GrizzlyAdams) 2007
// Based on DSWifi Test Project - copyright Stephen Stair 2005
// Based on template project in ndslib by wntrmute
/****************************************************************************** 
DSWifi Lib and test materials are licenced under the MIT open source licence:
Copyright (c) 2005 Stephen Stair

MythRemote is also licensed under the MIT open source license:
Copyright (c) 2007 David Kuder

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
******************************************************************************/


// Global Includes

#include <libini.h>
#include <libskin.h>


// Local Includes

#include "mythremoteipc.h"
#include "3deffect.h"


#include "ascii_bin.h"
#include "waitgfx_bin.h"
#include "splash_pcx.h"
#include "check_pcx.h"





// Constants

#define	VRAM1	((u16 *) 0x06000000)
#define	VRAM2	((u16 *) 0x06200000)
#define	VCOUNT	(*((u16 volatile *) 0x04000006))
#define PAL_BG1	((volatile u16 *)0x05000000)
#define PAL_BG2	((volatile u16 *)0x05000400)
#define RGB(r,g,b) ((r) | ((g)<<5) | ((b)<<10))


#define HT_MYTH	0x0000
#define HT_XBMC	0x0001



// Types

typedef struct Host_s {
	unsigned long IP;
	unsigned short Port;
	int Type;
} Host_t;





// Variables

int tcp_sock;
int tcp_echo;
char tcp_config[256];
char tcp_temp[256];
struct hostent * tcp_he;
struct sockaddr_in tcp_sain;

extern int splash_fade;
extern Host_t Host[3];

extern touchPosition touchXY;

extern unsigned short UpdatePort;

extern int DEBUG;
extern int NO3D;

extern Skin_t Skin;

extern unsigned short *TopScreen;
extern unsigned short *BottomScreen;
extern unsigned short BackBuffer[256*256];
extern int screen_on;

extern int framectr;


extern ButtonPanel_t ConfigMenu;


// Functions

extern void WaitVbl();
extern void ClsBtm();

extern int Do_ConfigureWifi();

extern void Do_Remote(void *);
extern void Do_Config(void *);
extern void Do_Update(void *);
extern void Do_IPConfig(void *);
extern void Do_PortConfig(void *);
extern void Do_LoadConfig(void *);
extern void Do_SaveConfig(void *);

extern void Do_PowerOff(void *);
extern void Do_Sleep(void *);
extern void Do_Sleep2(void *);
extern void Do_Reset(void *);
extern void SendCommand(void*);
extern void DisconnectFrontend(void*);
extern void PrevScreen(void*);
extern void NextScreen(void*);
extern void SelectBox(void*);
extern void PushIPDigit(void*);
extern void PopIPDigit(void*);
extern void PushPortDigit(void*);
extern void PopPortDigit(void*);

extern void Do_Dialog(char *);
extern void Timer_50ms(void);

extern void GenerateSkin(void);

extern void UpdateMenu(ButtonPanel_t *pPanel, int NewSelected);
extern void RenderMenu(ButtonPanel_t *pPanel, unsigned short *Screen);
extern void Display2D(int Black);
extern int AntiEffect(int Effect);
extern void Transition(int Effect, void *param);
extern void LCD_FadeIn(ButtonPanel_t *pPanel);
extern void LCD_FadeOut(ButtonPanel_t *pPanel);
extern int InputMenu(ButtonPanel_t *pPanel);

extern void Do_Menu(void *param);
extern void CloseDialog(void *arg);

extern void printbtm(int x, int y, const char *Text);
extern void printtop(char *Text);

extern void __fifoIRQ();
extern void fifoSend(unsigned long v);
extern void fifo_WiFiSync();
extern void fifo_WiFiInit(u32 value);


