// MythRemote - copyright David Kuder (GrizzlyAdams) 2007
// Based on DSWifi Test Project - copyright Stephen Stair 2005
// Based on template project in ndslib by wntrmute
/****************************************************************************** 
DSWifi Lib and test materials are licenced under the MIT open source licence:
Copyright (c) 2005 Stephen Stair

MythRemote is also licensed under the MIT open source license:
Copyright (c) 2007 David Kuder

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
******************************************************************************/

enum SGIP_TCP_STATE {
	SGIP_TCP_STATE_NODATA, // newly allocated
	SGIP_TCP_STATE_UNUSED, // allocated & BINDed
	SGIP_TCP_STATE_LISTEN, // listening
	SGIP_TCP_STATE_SYN_SENT, // connect initiated
	SGIP_TCP_STATE_SYN_RECEIVED, // spawned from listen socket;
	SGIP_TCP_STATE_ESTABLISHED, // syns have been exchanged
	SGIP_TCP_STATE_FIN_WAIT_1, // sent a FIN, haven't got FIN or ACK yet.
	SGIP_TCP_STATE_FIN_WAIT_2, // got ACK for our FIN, haven't got FIN yet.
	SGIP_TCP_STATE_CLOSE_WAIT, // got FIN, wait for user code to close socket & send FIN
	SGIP_TCP_STATE_CLOSING, // got FIN, waiting for ACK of our FIN
	SGIP_TCP_STATE_LAST_ACK, // wait for ACK of our last FIN
	SGIP_TCP_STATE_TIME_WAIT, // wait to ensure remote tcp knows it's been terminated.
	SGIP_TCP_STATE_CLOSED, // Block is unused.
};

int gettcpstate(int socket);
