// MythRemote - copyright David Kuder (GrizzlyAdams) 2007
// Based on DSWifi Test Project - copyright Stephen Stair 2005
// Based on template project in ndslib by wntrmute
/****************************************************************************** 
DSWifi Lib and test materials are licenced under the MIT open source licence:
Copyright (c) 2005 Stephen Stair

MythRemote is also licensed under the MIT open source license:
Copyright (c) 2007 David Kuder

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
******************************************************************************/


#include "nds.h"
#include <nds/arm9/console.h>		//basic print funcionality
#include <nds/arm9/image.h>		//needed to load pcx files


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <errno.h>

#include <fat.h>
#include <cartreset.h>

#include "tcpstate.h"

// Redefined this in the wifi libs so we need to deal with that.
#undef FD_SETSIZE

#include <dswifi9.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "mythremote.h"

void Do_Update(void *arg) {
	int TransferFailed=0;
	int to=0, ti=0, i;
	FILE *of;
	struct sockaddr_in addr = { 0 };
	int addrSize;
	int newfd;
	char text[512];
	uint32 my_ip;

	BLEND_Y=31;

	Do_ConfigureWifi();

	tcp_sock = socket(AF_INET,SOCK_STREAM,0);
	if(tcp_sock == -1) {
		Do_Dialog("Failed to allocate socket.");
		return;
	}

	i=1;
	ioctl(tcp_sock,FIONBIO,&i); // set non-blocking

	addr.sin_family = AF_INET;
	addr.sin_port = htons(UpdatePort);

	bind(tcp_sock, (struct sockaddr *) &addr, sizeof addr);
	listen(tcp_sock, 2);

	my_ip = Wifi_GetIP();
	sprintf(text, "%d.%d.%d.%d:%d",
		my_ip & 0xFF,
		(my_ip >> 8) & 0xFF,
		(my_ip >> 16) & 0xFF,
		(my_ip >> 24) & 0xFF,
		UpdatePort);

	int frame=0;
	while((newfd = accept(tcp_sock, (struct sockaddr *) &addr, &addrSize))<0) {
		frame++;
		WaitVbl();
		ClsBtm();
		// Process Input
		if(keysDown()&KEY_B) {
			close(tcp_sock);
			Wifi_DisconnectAP();
			Wifi_DisableWifi();
			return;
		}
		if(keysDown()&KEY_TOUCH) {
			// "cancel" - center of (16,21) to center of (31,23)
			if(touchXY.px>=(96) && touchXY.px<(96+64) && touchXY.py>=(156) && touchXY.py<(156+16)) {
				close(tcp_sock);
				Wifi_DisconnectAP();
				Wifi_DisableWifi();
				return;
			}
		}

		// Draw info
		BlitCenterText(&Skin, 56, "Listening for connections...", Skin.Button.Highlight, BottomScreen);
		BlitCenterText(&Skin, 64, text, Skin.Button.Highlight, BottomScreen);
		Button_t CancelButton = {
			96,156,64,16,libskin_BC_Normal, libskin_BS_Normal, 0, "Cancel", NULL, NULL, 0
		};

		DrawButton(&Skin, &CancelButton, BottomScreen);
		BlitCenterText(&Skin, 184,"[B]Cancel", Skin.Button.Highlight, BottomScreen);

		Blit_t BlockRect = { 0, 24*((frame>>2)&0x7), 24, 24, 24, (unsigned short *) WAITGFX_bin };
		Blit_t ScreenRect = { 116, 112, 24, 24, 256, BottomScreen };
		MyBlitter(&BlockRect, &ScreenRect);
	}


	if(newfd>0) {
		i=1;
		ioctl(newfd,FIONBIO,&i); // set non-blocking

		sprintf(text, "Accepted %lu.%lu.%lu.%lu:%d",
			addr.sin_addr.s_addr & 0xFF,
			(addr.sin_addr.s_addr >> 8) & 0xFF,
			(addr.sin_addr.s_addr >> 16) & 0xFF,
			(addr.sin_addr.s_addr >> 24) & 0xFF,
			ntohs(addr.sin_port));
		printtop(text);

		of=fopen("fat0:/mythremote.test.nds", "w");
		if(of==NULL) {
			Do_Dialog("Unable to open output file.");
			TransferFailed=1;
		}

		while(!TransferFailed) {
			int rb,wb,fbi;
			char fbuf[4096];
		
//			i = gettcpstate(newfd);
//			if(i>=SGIP_TCP_STATE_FIN_WAIT_1) {
//				break;
//			}		

			rb=recv(newfd, fbuf, 4096, 0);
			if(rb>0) {
				ti+=rb;

				fbi=0;
				while(rb && !TransferFailed) {
					wb=fwrite(fbuf+fbi, 1, rb, of);
					if(wb>0) {
						rb-=wb;
						fbi+=wb;
						to+=wb;
					} else {
						TransferFailed=1;
					}
				}
			}
//			if(rb<0) {
//				break;
//			}

			frame++;
			WaitVbl();
			ClsBtm();

			sprintf(text, "%9i bytes Transfered.", to);
			BlitCenterText(&Skin, 8, text, Skin.Button.Highlight, BottomScreen);

			// Process Input
			if(keysDown()&KEY_B) {
				if(of!=NULL) fclose(of);
				close(newfd);
				close(tcp_sock);
				Wifi_DisconnectAP();
				Wifi_DisableWifi();
				return;
			}
			if(keysDown()&KEY_TOUCH) {
				// "cancel" - center of (16,21) to center of (31,23)
				if(touchXY.px>=(96) && touchXY.px<(96+64) && touchXY.py>=(156) && touchXY.py<(156+16)) {
					if(of!=NULL) fclose(of);
					close(newfd);
					close(tcp_sock);
					Wifi_DisconnectAP();
					Wifi_DisableWifi();
					return;
				}
			}

			// Draw info
			Button_t CancelButton = {
				96,156,64,16,libskin_BC_Normal, libskin_BS_Normal, 0, "Cancel", NULL, NULL, 0
			};
			DrawButton(&Skin, &CancelButton, BottomScreen);
			BlitCenterText(&Skin, 184,"[B]Cancel", Skin.Button.Highlight, BottomScreen);
		}
		if(of!=NULL) fclose(of);

		shutdown(newfd, SHUT_RDWR);
		Timer_50ms();
		close(newfd);

	}

	shutdown(tcp_sock, SHUT_RDWR);
	Timer_50ms();
	close(tcp_sock);

	Wifi_DisconnectAP();
	Wifi_DisableWifi();
	
	if(TransferFailed) {
		Do_Dialog("Download failed.");
		return;
	}

	Do_Dialog("Download done.");

	return;
}
