// MythRemote - copyright David Kuder (GrizzlyAdams) 2007
// Based on DSWifi Test Project - copyright Stephen Stair 2005
// Based on template project in ndslib by wntrmute
/****************************************************************************** 
DSWifi Lib and test materials are licenced under the MIT open source licence:
Copyright (c) 2005 Stephen Stair

MythRemote is also licensed under the MIT open source license:
Copyright (c) 2007 David Kuder

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
******************************************************************************/


#include "nds.h"
#include <nds/arm9/console.h>		//basic print funcionality
#include <nds/arm9/image.h>		//needed to load pcx files


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <errno.h>

#include <fat.h>
#include <cartreset.h>

#include "mythremote.h"

// Redefined this in the wifi libs so we need to deal with that.
#undef FD_SETSIZE

#include <dswifi9.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>




void WaitVbl() {
	swiWaitForVBlank();

	if(splash_fade>330) {
		SUB_BLEND_CR = BLEND_FADE_BLACK | BLEND_SRC_BG3;
		SUB_BLEND_Y = splash_fade-330;
	}

	if(splash_fade>0) {
		splash_fade--;
		if(splash_fade<31) {
			SUB_BLEND_CR = BLEND_FADE_BLACK | BLEND_SRC_BG3;
			SUB_BLEND_Y = 31-splash_fade;
		}
//		if(splash_fade==0) {
//			fifoSend(IPC_TOPOFF);
//		}
	}


	scanKeys();
	framectr++;
	touchXY=touchReadXY();
}

void ClsBtm() {
	int i;
	for(i=0;i<256*192;i++)
		VRAM1[i]=0x8000;
}

void printbtm(int x, int y, const char *Text) {
	x*=8;
	y*=8;
	BlitText(&Skin, x, y, (char *)Text, Skin.Button.Highlight, BottomScreen);
}

void printtop(char *Text) {
	if(DEBUG) iprintf(Text);
	if(DEBUG) iprintf("\n");
//	memset(&TopScreen[184*256], 0, 256*8*2);
	
//	BlitCenterText(&Skin, 184, Text, Skin.Button.Highlight, TopScreen);
}

void sgIP_dbgprint(char * txt, ...) {
	char buffer[256];
	va_list args;
	va_start(args,txt);
	vsprintf(buffer,txt,args);
//	if(DEBUG) iprintf("%s\n", buffer);
	//	printtop(buffer);		
}
		


//---------------------------------------------------------------------------------
void __fifoIRQ()
//--------------------------------------------------------------------------------- 
{
	int syncd = 0;
	while ( !(REG_IPC_FIFO_CR & IPC_FIFO_RECV_EMPTY)) {
		u32 value = REG_IPC_FIFO_RX;
		if ( value == IPC_WIFISYNC9 && !syncd) {
			syncd = 1;
			Wifi_Sync();
		}
	} 
}

void fifoSend(unsigned long v) {
	while(REG_IPC_FIFO_CR & IPC_FIFO_SEND_FULL);
	REG_IPC_FIFO_TX = v;
}

void fifo_WiFiSync() {
	fifoSend(IPC_WIFISYNC7);
}

void fifo_WiFiInit(u32 value) {
	fifoSend(IPC_WIFIINIT);
	fifoSend(value);
}
		
void Timer_50ms(void) {
   Wifi_Timer(50);
}

void LCD_FadeIn(ButtonPanel_t *pPanel) {
	powerON(POWER_LCD);
	Transition(Effect_Fade | Effect_In, pPanel);
}

void LCD_FadeOut(ButtonPanel_t *pPanel) {
	Transition(Effect_Fade, pPanel);
	powerOFF(POWER_LCD);
}

const char * assocstatus_strings[] = {
	"ASSOCSTATUS_DISCONNECTED",		// not *trying* to connect
	"ASSOCSTATUS_SEARCHING",		// data given does not completely specify an AP, looking for AP that matches the data.
	"ASSOCSTATUS_AUTHENTICATING",	// connecting...
	"ASSOCSTATUS_ASSOCIATING",		// connecting...
	"ASSOCSTATUS_ACQUIRINGDHCP",	// connected to AP, but getting IP data from DHCP
	"ASSOCSTATUS_ASSOCIATED",		// Connected!
	"ASSOCSTATUS_CANNOTCONNECT",	// error in connecting...
};

int Do_ConnectAP() {
	int j,state,delay;
	int frame=0;
	//char tmpbuf[64];
	delay=0;
	Wifi_DisconnectAP();

	BLEND_Y=31;

	// set startup state...
	j=0;
	state=5;
	while(1) {
		frame++;
		WaitVbl();
		ClsBtm();
		// Process Input
		if(keysDown()&KEY_B) {
			Wifi_DisconnectAP();
			Wifi_DisableWifi();
			return 0;
		}
		if(keysDown()&KEY_TOUCH) {
			// "cancel" - center of (16,21) to center of (31,23)
			if(touchXY.px>=(96) && touchXY.px<(96+64) && touchXY.py>=(156) && touchXY.py<(156+16)) {
				Wifi_DisconnectAP();
				Wifi_DisableWifi();
				return 0;
			}
		}

		// Draw info
		BlitCenterText(&Skin, 8, "Connecting to AP...", Skin.Button.Highlight, BottomScreen);
		Button_t CancelButton = {
			96,156,64,16,libskin_BC_Normal, libskin_BS_Normal, 0, "Cancel", NULL, NULL, 0
		};
		DrawButton(&Skin, &CancelButton, BottomScreen);
		BlitCenterText(&Skin, 184,"[B]Cancel", Skin.Button.Highlight, BottomScreen);

//		if(state==6) {
			Blit_t BlockRect = { 0, 24*((frame>>2)&0x7), 24, 24, 24, (unsigned short *) WAITGFX_bin };
			Blit_t ScreenRect = { 116, 112, 24, 24, 256, BottomScreen };
			MyBlitter(&BlockRect, &ScreenRect);
//		}

		// draw state info & processing.
		switch(state) {

		case 5: // connect to AP
			state=6;
			Wifi_AutoConnect();
		case 6:
			j=Wifi_AssocStatus();
			// "0123456789ABCDEF0123456789ABCDEF"
//			BlitCenterText(&Skin, 16, "Connecting to Access Point...", Skin.Button.Highlight, BottomScreen);
//			BlitCenterText(&Skin, 32, (char *)assocstatus_strings[j], Skin.Button.Highlight, BottomScreen);
			if(j == ASSOCSTATUS_ASSOCIATED) state=30;
			if(j == ASSOCSTATUS_CANNOTCONNECT) state=20;
			break;		

		case 20:
			BlitCenterText(&Skin, 16, "Cannot connect to Access Point.", Skin.Button.Highlight, BottomScreen);
			BlitCenterText(&Skin, 32,"(Hit Cancel to continue)", Skin.Button.Highlight, BottomScreen);
			break;

		case 30:
			delay=60;
			state=31;
		case 31:
			return 1;
			break;
		}
	}
}

int Do_ConfigureWifi() {
	printtop("Do_ConfigureWifi");
	Wifi_EnableWifi();
	Wifi_ScanMode();
	return Do_ConnectAP();	
}

void Do_Sleep(void *arg) {
	fifoSend(IPC_SLEEP);
	scanKeys();
	while(keysHeld() & KEY_LID) {
		scanKeys();
		WaitVbl();
	}
}

void Do_Sleep2(void *arg) {
	fifoSend(IPC_SLEEP);
	scanKeys();
	while(keysDown() & ~KEY_LID) {
		scanKeys();
		WaitVbl();
	}
}

void Do_PowerOff(void *arg) {
	fifoSend(IPC_POWEROFF);
	while(1);
}

void Do_Reset(void *arg) {
	WaitVbl();
	ClsBtm();
	if(cartSetMenuMode(DEVICE_TYPE_AUTO)) {
		printtop("Recognized device!");
		WaitVbl();
		WaitVbl();
		fifoSend(IPC_CARTRESET);
		passmeloopEnter();
		while(1);
	} else {
		printtop("Unknown device!");
	}
}
