// MythRemote - copyright David Kuder (GrizzlyAdams) 2007
// Based on DSWifi Test Project - copyright Stephen Stair 2005
// Based on template project in ndslib by wntrmute
/****************************************************************************** 
DSWifi Lib and test materials are licenced under the MIT open source licence:
Copyright (c) 2005 Stephen Stair

MythRemote is also licensed under the MIT open source license:
Copyright (c) 2007 David Kuder

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
******************************************************************************/

#ifndef __LIBINI_H
#define __LIBINI_H

typedef struct libini_Key_s {
	struct libini_Key_s *Next;
	char *Name;
	char *Value;
} libini_Key_t;

typedef struct libini_Section_s {
	struct libini_Section_s *Next;
	struct libini_Key_s *Keys;
	char *Name;
} libini_Section_t;

typedef struct libini_File_s {
	libini_Section_t *Sections;
} libini_File_t;

void libini_Free(libini_File_t * inifile);
libini_File_t * libini_Create();
libini_File_t * libini_Load(const char *filename);
int libini_Save(libini_File_t * inifile, const char *filename);
char * libini_ReadString(libini_File_t * inifile, const char *sectionname, const char *keyname, char *def);
int libini_ReadInt(libini_File_t * inifile, const char *sectionname, const char *keyname, int def);
unsigned long libini_ReadULong(libini_File_t * inifile, const char *sectionname, const char *keyname, unsigned long def);
libini_Key_t * libini_WriteString(libini_File_t * inifile, const char *sectionname, const char *keyname, char *value);
libini_Key_t * libini_WriteInt(libini_File_t * inifile, const char *sectionname, const char *keyname, int value);
libini_Section_t * libini_FindSection(libini_File_t * inifile, const char *sectionname);

#endif
