// MythRemote - copyright David Kuder (GrizzlyAdams) 2007
// Based on DSWifi Test Project - copyright Stephen Stair 2005
// Based on template project in ndslib by wntrmute
/****************************************************************************** 
DSWifi Lib and test materials are licenced under the MIT open source licence:
Copyright (c) 2005 Stephen Stair

MythRemote is also licensed under the MIT open source license:
Copyright (c) 2007 David Kuder

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
******************************************************************************/

#ifndef __LIBSKIN_H
#define __LIBSKIN_H

#define 	libskin_BS_Normal		0x0000
#define 	libskin_BS_Highlight	0x0001
#define 	libskin_BS_Pressed	0x0002

#define 	libskin_BC_Invalid	0x0000
#define 	libskin_BC_Normal		0x0001
#define 	libskin_BC_Toggle		0x0002
#define 	libskin_BC_CheckBox	0x0003
#define 	libskin_BC_RadioGroup	0x0010
#define 	libskin_BC_RadioGroup1	0x0011
#define 	libskin_BC_RadioGroup2	0x0012
#define 	libskin_BC_RadioGroup3	0x0013
#define 	libskin_BC_RadioGroup4	0x0014

#define	libskin_IAX_Direct	0x0000
#define	libskin_IAX_Left		0x0001
#define	libskin_IAX_Right		0x0002
#define	libskin_IAX_Center	0x0003

#define	libskin_IAY_Direct	0x0000
#define	libskin_IAY_Top		0x0001
#define	libskin_IAY_Bottom	0x0002
#define	libskin_IAY_Center	0x0003

typedef struct Button_s {
  int X,Y,W,H;
  int Class;
  int State;
  bool Checked;
  char *Label;
  void (*Function)(void *);
  void *Argument;
  int Transition;
} Button_t;

typedef struct ButtonPanel_s {
  bool CursorInput;
  int Selected;
  int TouchState;
  int Frames;
  bool Exit;
  int Transition;
  Button_t *ButtonList;
} ButtonPanel_t;

typedef struct Skin_s {
  unsigned short Backdrop[256*192];
  struct {
    int AlignX,AlignY;
    unsigned short Highlight;
    unsigned short Shadow;
    unsigned short Image[4][256*32];
  } Button;
  unsigned short Radio[2][12*12];
  unsigned short Check[2][12*12];
  unsigned char Font[8*8*256];
  unsigned short TextColor;
} Skin_t;

typedef struct Blit_s {
	int X,Y;		// Origin
	int W,H;		// Size
	int LW;		// Line width in pixels
	unsigned short *Image;
} Blit_t;

extern void MyBlitter(Blit_t *SRC, Blit_t *DST);

extern void DrawButton(Skin_t *, Button_t *, unsigned short *);
extern void DrawButtonPanel(Skin_t *, ButtonPanel_t *, unsigned short *);
extern void DrawBackdrop(Skin_t *Skin, unsigned short *Screen);
extern void BlitText(Skin_t *Skin, int oX, int oY, char *Text, unsigned short Color, unsigned short *Screen);
extern void BlitCenterText(Skin_t *Skin, int oY, char *Text, unsigned short Color, unsigned short *Screen);

#endif
